#!/bin/bash
curdir=`pwd`
http=http
port=8080
passk=""
SSL=""

usage()
{
    if [ -n "$1" ] ; then
        echo "ERROR: $1"
        echo
    fi

    cat <<EOF
Usage:
    $ME [options]

      <AmbariAdminUserName>  AmbariAdminUserName     Specify Cluster manager Ambari Admin User Name
      <SSLENABLED>           SSLENABLED              Optional: Pass the value SSL if Ambari cluster manager is SSL enabled
      <SSLPORT>              SSLPORT                 Optional: Specify Ambari cluster manager's SSL port defaults to 8443

EOF
    exit 1
}


if [ ! -z "$2" ]
then
    http=https
    port=8443
    passk=-k
    SSL=-s
    if [ ! -z "$3" ]
    then
         port=$3
    fi
fi
if [[ $# -lt 1 ]]
then
    echo "The delete_stack.sh script requires one arguments: <ambariAdminUsername>."
    usage
    exit

fi

echo "Enter the Ambari admin password."
read -s password
sudo -n true
if [ $? -ne 0 ]
   then
   echo "You do not have root privileges to execute this script. Please rerun the script with a root or password-less sudo account."
   exit 1
fi
clusterName=`sudo curl $passk --silent -u $1:$password -H "X-Requested-By:ambari" -X GET $http://localhost:$port/api/v1/clusters|grep cluster_name|cut -d ":" -f 2|cut -d '"' -f 2`
host=`sudo curl $passk --silent -u  $1:$password -H "X-Requested-By:ambari" -X GET $http://localhost:$port/api/v1/clusters/$clusterName/services/HDATPLUGINS/components/HDATPLUGINS_CLIENT|grep host_name|cut -d ":" -f 2`
for i in $host; do
	sudo curl $passk --output /tmp/test.log -u $1:$password -H "X-Requested-By:ambari" -i -X POST -d '{"RequestInfo" : {"command" : "uninstall_hdatplugins","context" : "Uninstall HDATPLUGINS service"},"Requests/resource_filters": [{"service_name" : "HDATPLUGINS","component_name" : "HDATPLUGINS_CLIENT","hosts" :'$i'}]}' $http://localhost:$port/api/v1/clusters/$clusterName/requests
        sleep 20
done
sleep 20

response=$(sudo curl $passk --silent --write-out "\n%{http_code}\n" -u $1:$password -H "X-Requested-By:ambari" -X DELETE  $http://localhost:$port/api/v1/clusters/$clusterName/services/HDATPLUGINS)

status_code=$(echo "$response" | sed -n '$p')
html=$(echo "$response" | sed '$d')

echo $html
echo $status_code
if [[ $status_code -ne 200 ]]
then
	echo "Failed to remove HDATPLUGINS stack component"
        echo "The HDATPLUGINS stack is already deleted or is not installed on the Ambari server."
        exit
fi


if [ -d /var/lib/ambari-server/resources/stacks/HDP/2.0.6/services/HDATPLUGINS ]
then
	sudo rm -rf /var/lib/ambari-server/resources/stacks/HDP/2.0.6/services/HDATPLUGINS
        sudo rm -rf /var/lib/ambari-server/resources/HDATPLUGINS.*
fi

if [ -d /var/lib/ambari-server/resources/stacks/HDP/3.0/services/HDATPLUGINS ]
then
        sudo rm -rf /var/lib/ambari-server/resources/stacks/HDP/3.0/services/HDATPLUGINS
        sudo rm -rf /var/lib/ambari-server/resources/HDATPLUGINS.*
fi
echo "To Complete uninstall process, ambari server needs to be restarted. Press y if you want script to perform restart or n if you want to perform restart manually later."
read response
if [[ $response == "y" || $response == "Y" ]]
then
	sudo /usr/sbin/ambari-server restart
else
	echo "Skipped Ambari server restart."
fi

